var iconStyle= new ol.style.Style({
		fill: new ol.style.Fill({
			color: 'rgba(255, 255, 255, 0.2)'
		}),
		stroke: new ol.style.Stroke({
			color: '#FF0000',
			width: 2
		}),
		image: new ol.style.Icon(/** @type {olx.style.IconOptions} */ ({
		anchor: [0.5,16],
			anchorXUnits: 'fraction',
			anchorYUnits: 'pixels',
			src: 'image/sign.png'
		}))
	});
class drawFence{
    //转换坐标点（多）
    transPoints(points) {
        var _points = new Array();
        let newPoint = points.split(',');
        for(var i = 0 ; i<newPoint.length ;){
			var item = [parseFloat(newPoint[i+1]), parseFloat(newPoint[i])];
			i+=2;
			_points.push(item);
		}
        return _points;
    }
   
    transPoint(point) {
		var _point=[];
        let item = point.split(',');
        _point=[parseFloat(item[1]), parseFloat(item[0])];
        return _point;
    }

    showCircle(map,center, radius, name,comment) {

        let centerPoint = this.transPoint(center)
        radius = parseFloat(radius);
		var circleIn3857 = new ol.geom.Circle(ol.proj.transform(centerPoint, 'EPSG:4326', 'EPSG:3857'), radius,'XY');
		
		var circleIn4326 = circleIn3857.transform('EPSG:3857','EPSG:4326');
		
        var circleFeature = new ol.Feature({ //路线
			 name:name,
			 comment:comment,
            geometry: circleIn4326
        });
        
        //将所有矢量图层添加进去
        map.addFeature(circleFeature);
    }

    showPolygon(map,points, name,comment) {
        let _points = this.transPoints(points)
        _points = [_points]
        //多边形的数据格式是[[[lng,lat],[lng,lat]……]]外围两个中括号
        var polygonFeature = new ol.Feature({ //图形
			name:name,
			comment:comment,
            geometry: new ol.geom.Polygon(_points)

        });
        
        map.addFeature(polygonFeature);
      
    }

    showPolyline(map,points, name,comment) {

        let _points = this.transPoints(points)
        var lineFeature = new ol.Feature({ //路线
			name:name,
			comment:comment,
            geometry: new ol.geom.LineString(_points, 'XY')
        });
        

        //将所有矢量图层添加进去
        map.addFeature(lineFeature);
    }
	
	ShowPoint(map,Points,name,comment){
		let Point = this.transPoint(Points)
        
        var Sign = new ol.Feature({ //路线
            geometry: new ol.geom.Point(Point),
			name:name,
			comment:comment
        });
        
		
		Sign.setStyle(iconStyle);
		
        //将所有矢量图层添加进去
        map.addFeature(Sign);
	}
	
    //回显围栏
    showFence(obj) {
        let {
			map,
            name,
			comment,
            type,
            center,
            radius,
            points
        } = obj;
        if (type == 'polygon') {
            this.showPolygon(map, points, name,comment);
        }
        if (type == 'circle') {
            this.showCircle(map, center, radius, name,comment);
        }
        if (type == 'polyline'){
			this.showPolyline(map, points, name,comment);
		} 
		if (type == 'Point'){
			this.ShowPoint(map,points,name,comment);
		}
    }

}
