//发送消息结构体
function CreateMsgObj(UserID,ObjList){
	var Obj = new Object;
	Obj.UserID = parseFloat(UserID);
	if(typeof(ObjList)!="undefined")
		Obj.TxtMsg = ObjList;
	
	return Obj;
}
//消息对象中，标签结构体
function CreateMsgSign(Name,Icon,SignObj){
	var Sign = new Object;
	Sign.Type = 7;
	Sign.Name = Name;
	Sign.Icon = Icon;
	Sign.ExtData = SignObj;
	return Sign;	
}
//消息对象中，轨迹结构体
function CreateMsgTrack(Index,Name,TrackObj){
	var Track = new Object;
	Track.Type = 8;
	Track.Index = Index;
	Track.ExtType = 8;
	Track.ExtData = TrackObj;
	Track.Name = Name;
	return Track;
}
//消息对象中，图形结构体
function CreateMsgShape(Index,Name,ShapeObj){
	var Shape = new Object;
	Shape.Type = 13;
	Shape.Index = Index;
	Shape.ExtType = 13;
	Shape.ExtData = ShapeObj;
	Shape.Name = Name;
	return Shape;
}
//消息对象中图片结构体
function CreateMsgPic(Width,Height,Name,ExtDatas){
	var Pic = new Object;
	Pic.Type = 22;
	Pic.ExtType = 22;
	Pic.Width = Width;
	Pic.Height = Height;
	Pic.Name = Name;
	Pic.ExtData = ExtDatas;
	return Pic;
}
//消息对象中文件结构体
function CreateMsgFile(Name,ExtDatas){
	var File = new Object;
	File.Type = 22;
	File.ExtType = 22;
	File.Name = Name;
	File.ExtData = ExtDatas;
	return File;
}

//上传云收藏对象数据结构体
function CreateFavObj(ParentID,MinSnID,MaxSnID,ObjList){
	var Obj = new Object;
	var ObjectDetail1 = new Object;
	var FavoriteObjData = new Object;
	
	ObjectDetail1.Child = ObjList.length;
	ObjectDetail1.ObjChildren  = ObjList;
	
	FavoriteObjData.Name = "Group1";
	FavoriteObjData.Type = 30;
	FavoriteObjData.ObjectDetail = ObjectDetail1;
	
	Obj.ParentID = ParentID;
	Obj.MinSnID = MinSnID;
	Obj.MaxSnID = MaxSnID;
	Obj.FavoriteObjData = FavoriteObjData;
	
	return Obj;
	
}

//上传云收藏夹对象中，标签结构体
function CreateFavSign(Name,SignObj){
	var Sign = new Object;
	Sign.Type = 7;
	Sign.Name = Name;
	Sign.Object = SignObj;
	return Sign;	
}
//上传云收藏夹对象中，轨迹结构体
function CreateFavTrack(Index,Name,TrackObj){
	var Track = new Object;
	Track.Type = 8;
	Track.Index = Index;
	Track.ExtType = 8;
	Track.Object = TrackObj;
	Track.Name = Name;
	return Track;
}
//上传云收藏夹对象中，图形结构体
function CreateFavShape(Index,Name,ShapeObj){
	var Shape = new Object;
	Shape.Type = 13;
	Shape.Index = Index;
	Shape.ExtType = 13;
	Shape.Object = ShapeObj;
	Shape.Name = Name;
	return Shape;
}

//上传共享云端数据结构体
function CreateCloudObj(Name,ParentID,ListObj,Comment){

	var Obj = new Object;
	var ObjGroup1 = new Object;
	var ObjectDetail1 = new Object;
	var Rights1 = new Array();
	var Rs = new Object;
	
	Rs.UserID = 0;
	Rs.Right = 7;
	Rights1.push(Rs);
	
	ObjectDetail1.ObjChildren = ListObj;
	ObjectDetail1.Relate = 0;
	ObjectDetail1.NotHotId = 0;
	ObjectDetail1.ReadOnly = 0;
	ObjectDetail1.Crypt = 0;
	ObjectDetail1.Child = ListObj.length;
	
	ObjGroup1.ObjectDetail = ObjectDetail1;
	ObjGroup1.Type = 30;
	ObjGroup1.Name = "";
	
	Obj.ObjGroup = ObjGroup1;
	Obj.Rights = Rights1;
	Obj.Comment = Comment;
	Obj.Name = Name;
	Obj.OwnerID = 9999;
	Obj.CryptID = 0;
	Obj.ObjID = 0;
	Obj.ParentID = ParentID;
	
	return Obj;	
}


//上传共享云端对象中，标签结构体
function CreateCloudSign(Name,SrvID,SignObj,tmModify){
	
	var Sign = new Object;
	Sign.Type = 7;
	Sign.SrvID = SrvID;
	Sign.ObjID = 0;
	Sign.Name = Name;
	Sign.tmModify = tmModify;
	Sign.MD5 = 0;
	Sign.Change = 0;
	Sign.Select = 0;
	Sign.Object = SignObj;
	return Sign;	
}
//上传共享云端对象中，轨迹结构体
function CreateCloudTrack(Name,SrvID,TrackObj,tmModify){
	var Track = new Object;
	Track.Type = 8;
	Track.SrvID = SrvID;
	Track.ObjID = 0;
	Track.Name = Name;
	Track.tmModify = tmModify;
	Track.MD5 = 0;
	Track.Change = 0;
	Track.Select = 0;
	Track.Object = TrackObj;
	return Track;
}
//上传共享云端对象中，图形结构体
function CreateCloudShape(Name,SrvID,ShapeObj,tmModify){
	var Shape = new Object;
	Shape.Type = 13;
	Shape.SrvID = SrvID;
	Shape.ObjID = 0;
	Shape.Name = Name;
	Shape.tmModify = tmModify;
	Shape.MD5 = 0;
	Shape.Change = 0;
	Shape.Select = 0;
	Shape.Object = ShapeObj;
	
	return Shape;
}



function CreateSign(Name,Comment,Lat,Lng,RealLl,SignPic){
		var Sign = new Object;
		var ObjectDetail = new Object;
		var SignEvent = new Object;
		
		var SignPics = new Object;
		
		SignEvent.Radius = 0;
		SignEvent.ShowClr = 0;
		SignPics.SignPic = SignPic;
	
		SignPics.AlignFlag = 0;
		SignPics.PicScale = 0;
		SignPics.SignPicNum = 0;
		SignPics.SignPicNumOffx = 0;
		SignPics.SignPicNumOffy = 0;
		SignPics.SignPicNumClr = 0;
		SignPics.SignPicNumSize = 0;
	
		ObjectDetail.Lat = Lat;
		ObjectDetail.Lng= Lng;
		ObjectDetail.RealLl = RealLl;
		ObjectDetail.Altitude = 0;
		ObjectDetail.EditMode = 0;
		ObjectDetail.OverlayIdx = 0;
		ObjectDetail.TxtType = 1;
		ObjectDetail.ShowLevel = 0;
		ObjectDetail.ShowLevelBak = 0;
		ObjectDetail.ShowLevelMax = 0;
		ObjectDetail.TimeUncertain = 0;
		ObjectDetail.TxtShowSta = 0;
		ObjectDetail.TxtShowStaSet = 0;
		ObjectDetail.SignEvent = SignEvent;
		ObjectDetail.SignEvent = SignEvent;
		ObjectDetail.SignPic = SignPics;
	
		Sign.ObjectDetail = ObjectDetail;
		Sign.Name = Name;
		Sign.Comment = Comment;
		Sign.Type = 7;
		
		return Sign;
}


function CreateTrack(Name,Comment,RealLl,Mtp,Latlng){
	var Track = new Object;
	
	var ObjectDetail = new Object;
	var TrackDraw = new Object;
	
	TrackDraw.LineClr = 16053248;
	TrackDraw.LineWidth = 3;
	TrackDraw.LineAlpha = 50;
	TrackDraw.ShowType = 0;
	TrackDraw.LineType = 0;
	TrackDraw.CircleClr = 0;
	TrackDraw.CircleWidth = 0;
	TrackDraw.NeedDrawDetail = 0;
	TrackDraw.Close = 0;
	
	ObjectDetail.RealLl = RealLl;
	ObjectDetail.OverlayIdx = 0;
	ObjectDetail.TrackType = 0;
	ObjectDetail.ShowLevel = 0;
	ObjectDetail.ShowLevelMax = 0;
	ObjectDetail.ShowLevelBak = 0;
	ObjectDetail.AltitudeColor = 0;
	ObjectDetail.ShowName = 0;
	ObjectDetail.Edit = 0;
	ObjectDetail.TrackDraw = TrackDraw;
	ObjectDetail.Mtp = Mtp;
	ObjectDetail.Latlng = Latlng;
	
	Track.Name = Name;
	Track.Comment = Comment;
	Track.Type = 8;
	Track.ObjectDetail = ObjectDetail;
	
	return Track;
}

function CreateShape(Name,Comment,RealLl,Mtp,Latlng,StartAngle,EndAngle){
	var Shape = new Object;
	
	var ObjectDetail = new Object;
	
	ObjectDetail.RealLl = RealLl;
	ObjectDetail.OverlayIdx = 0;
	ObjectDetail.TrackType = 0;
	ObjectDetail.ShowLevel = 0;
	ObjectDetail.ShowLevelMax = 0;
	ObjectDetail.ShowLevelBak = 0;
	ObjectDetail.OuterRgnIdx = 0 ;
	ObjectDetail.EditMode = 0 ;
	ObjectDetail.ShowFlag = 0 ;
	ObjectDetail.LineClr = 255 ;
	ObjectDetail.LineWidth = 1 ;
	ObjectDetail.LineAlpha = 50;
	ObjectDetail.AreaClr = 255;
	ObjectDetail.AreaAlpha = 50;
	ObjectDetail.StartAngle = StartAngle;
	ObjectDetail.EndAngle = EndAngle;
	ObjectDetail.FillType = 0;
	ObjectDetail.FillSubType = 0;
	ObjectDetail.FillPattern = 0;
	ObjectDetail.FillChgClr = 0;
	ObjectDetail.FillRotate = 0;
	ObjectDetail.FillScale = 0;
	ObjectDetail.FillOffsetX = 0;
	ObjectDetail.FillOffsetY = 0;
	ObjectDetail.Mtp = Mtp;
	ObjectDetail.Latlng = Latlng;
	
	
	Shape.Name = Name;
	Shape.Comment = Comment;
	Shape.Type = 13;
	Shape.ObjectDetail = ObjectDetail;
	
	
	
	
	return Shape;
}

function CreateGroup(Name,Child,ChildObj,tmModify){
	
	var Groups = new Object;
	var ExtData1 = new Object;
	var ObjectDetail = new Object;
	
	ObjectDetail.Child = Child;
	ObjectDetail.LoadOk = 1;
	ObjectDetail.SaveMerge = 0;
	ObjectDetail.Group = 0;
	ObjectDetail.AutoLoad = 1;
	ObjectDetail.ShowLevel = 0;
	ObjectDetail.ShowLevelMax = 0;
	ObjectDetail.ShowLevelBak = 0;
	ObjectDetail.Crypt = 0;
	ObjectDetail.Share = 0;
	ObjectDetail.ReadOnly = 0;
	ObjectDetail.NotHotId = 0;
	ObjectDetail.Bind = 0;
	ObjectDetail.BindCheck = 0;
	ObjectDetail.Link = 0;
	ObjectDetail.LinkAutoCheck = 0;
	ObjectDetail.ChildiOverlay = 0;
	ObjectDetail.LinkUrl = "";
	ObjectDetail.Relate = 0;
	
	if(typeof(ChildObj)!="undefined")
	ObjectDetail.ObjChildren = ChildObj;
	
	ExtData1.Name = Name;
	ExtData1.Type = 30;
	ExtData1.ObjectDetail = ObjectDetail;
	
	Groups.Type = 30;
	
	Groups.tmModify = tmModify;
	Groups.Object = ExtData1;
	
	return Groups;
}

function CreateDir(Name,Title,RealLl,Unit,PStart,PEnd,Mp,PointList,SubTitle){
	var Dir = new Object;
	var ExtData1 = new Object;
	var ObjectDetail = new Object;
	var DirectionsSrh = new Object;
	var DirectionsUnit = new Object;
	var DirectionsUnitsArray = new Array();

	var PointStart  = new Object;
	var PointEnd = new Object;
	var PointViaArray = new Array();
	
	
	PointStart.Lat = PStart[0];
	PointStart.Lng = PStart[1];
	
	PointEnd.Lat = PEnd[0];
	PointEnd.Lng = PEnd[1];
	
	for(var i = 0 ; i<16;i++){
		PointViaArray.push(0);
	}
	
	DirectionsSrh.DirMode = 0;
	DirectionsSrh.PointStart=PointStart;
	DirectionsSrh.PointEnd = PointEnd;
	DirectionsSrh.PointVia = PointViaArray;
	
	for(var i = 0 ; i<Unit; i++){
		DirectionsUnitsArray.push({'Mp':Mp,'SubCount':10,'Type':0,'Title':"step"+(i+1),'SubTitle':SubTitle[i],'PointList':PointList[i]});	
	}
	
	
	
	ObjectDetail.Title=Title;
	ObjectDetail.DirStart="开始";
	ObjectDetail.DirEnd="结束";
	ObjectDetail.RealLl=1;
	ObjectDetail.OverlayIdx=0;
	ObjectDetail.ShowLevel=0;
	ObjectDetail.ShowLevelMax=0;
	ObjectDetail.ShowLevelBak=0;
	ObjectDetail.LineClr=16711680;
	ObjectDetail.LineWidth=7;
	ObjectDetail.LineAlpha=60;
	ObjectDetail.Edit=0;
	ObjectDetail.Unit=Unit;
	ObjectDetail.DirectionsSrh = DirectionsSrh;
	ObjectDetail.DirectionsUnits = DirectionsUnitsArray;
	
	ExtData1.Name = Name;
	ExtData1.Type = 11;
	ExtData1.ObjectDetail = ObjectDetail;
	
	Dir.Type = 11;
	
	Dir.Object = ExtData1;
	
	return Dir;
}